
package jpb_bank;

import java.util.ArrayList;

public class Startklasse
{
    public static void main(String[] args)
    {
    /* Siehe Bilddatei 170928_KLASSENDIAGRAMM_loesungsvorschlag_abi2014_aufgabe23.png für die Struktur dieses
       Projekts.
       Wir erzeugen erst mal ein paar Objekte von allen Klassen; da wir viele obligate bidirektionale Beziehungen
       vorliegen haben, uebergeben wir dem Konstruktor null und weisen dann spaeter die assoziierten Objekte zu.
       
        Das ist nicht elegant, funktioniert aber fuer unsere Zwecke erst mal.
        
        Beachten Sie auch, dass wir keinerlei Ueberpruefung vornehmen, ob die Objekte zueinander "passen" (also bspw.
        ob Herr Schmitt und Herr Maier beide das gleiche Girokonto haben o.ä.). 
        Aber das ist uns im Moment auch egal.
        
        (Loesung fuer die meisten Probleme: Aenderungs- und Loesch-Methoden anlegen, aber das machen wir erst noch)
        */
        
        // erst mal die statische Variable ueberziehungszinssatz:double in Girokonto initialisieren
        Girokonto.setUeberziehungszinssatz(1.3); // statische Variable / Methode ohne Objekt, sondern direkt unter Verwendung der Klasse!
        // System.out.println("Ueberziehungszinssatz (fuer alle Girokonten gueltig): " + Girokonto.getUeberziehungszinssatz() + " Prozent");
        
        // 11 Darlehen anlegen 
        Darlehen d1 = new Darlehen(null, 111111, 31312313, 3, 536); Darlehen d2 = new Darlehen(null, 222222, 13, 23, 56); Darlehen d3 = new Darlehen(null, 3333, 8698, 3, 156); Darlehen d4 = new Darlehen(null, 444444, 66555, 2, 213); Darlehen d5 = new Darlehen(null, 55555, 32325, 77, 74); Darlehen d6 = new Darlehen(null, 66666, 121, 8, 45); Darlehen d7 = new Darlehen(null, 7777, 77, 215, 91);Darlehen d8 = new Darlehen(null, 8888, 66555, 2, 213); Darlehen d9 = new Darlehen(null, 999999, 3332325, 7217, 734); Darlehen d10 = new Darlehen(null, 1006, 1555541, 833, 4715); Darlehen d11 = new Darlehen(null, 111, 312122, 74, 2291);
        
        // 5 Kontoinhaber anlegen
        Kontoinhaber k1 = new Kontoinhaber(null, 1, "Metz", "Jose"); Kontoinhaber k2 = new Kontoinhaber(null, 2, "Bayazitoglu", "Hanspeter"); Kontoinhaber k3 = new Kontoinhaber(null, 3, "Maier", "Miroslav"); Kontoinhaber k4 = new Kontoinhaber(null, 4, "Huber", "Pjotr"); Kontoinhaber k5 = new Kontoinhaber(null, 5, "Burger", "Ali");
        
        // 5 Girokonten mit jeweils einem Kontoinhaber
        Girokonto gk1 = new Girokonto(k1, 1, 3333); Girokonto gk2 = new Girokonto(k2, 4, 222); Girokonto gk3 = new Girokonto(k3, 441, 43333);  Girokonto gk4 = new Girokonto(k4, 45551, 3123);  Girokonto gk5= new Girokonto(k5, 566641, 12);

        // Den Kontoinhabern die Girokonten zuordnen und umgekehrt
        k1.setGirokonto(gk1); k2.setGirokonto(gk2); k3.setGirokonto(gk3); k4.setGirokonto(gk4); k5.setGirokonto(gk5);
        gk1.setKontoinhaber(k1);gk2.setKontoinhaber(k2);gk3.setKontoinhaber(k3);gk4.setKontoinhaber(k4); gk5.setKontoinhaber(k5);
        
        // Jeden Girokonto ein paar Darlehen zuordnen und jedem Darlehen sein Girokonto zuordnen
        ArrayList<Darlehen> listeFuerGirokonto1 = new ArrayList<Darlehen>(); listeFuerGirokonto1.add(d1); listeFuerGirokonto1.add(d2);listeFuerGirokonto1.add(d3);
            d1.setAbwicklungskonto(gk1); d2.setAbwicklungskonto(gk1); d3.setAbwicklungskonto(gk1);
            gk1.setDarlehen(listeFuerGirokonto1);
        ArrayList<Darlehen> listeFuerGirokonto2 = new ArrayList<Darlehen>(); listeFuerGirokonto2.add(d4); listeFuerGirokonto2.add(d5);
            d4.setAbwicklungskonto(gk2);d5.setAbwicklungskonto(gk2);
            gk2.setDarlehen(listeFuerGirokonto2);
        ArrayList<Darlehen> listeFuerGirokonto3 = new ArrayList<Darlehen>(); listeFuerGirokonto3.add(d6); listeFuerGirokonto3.add(d7);
            d6.setAbwicklungskonto(gk3);d7.setAbwicklungskonto(gk3);
            gk3.setDarlehen(listeFuerGirokonto3);
        ArrayList<Darlehen> listeFuerGirokonto4 = new ArrayList<Darlehen>(); listeFuerGirokonto4.add(d8);listeFuerGirokonto4.add(d9); listeFuerGirokonto4.add(d10); listeFuerGirokonto4.add(d11);
            d8.setAbwicklungskonto(gk4); d9.setAbwicklungskonto(gk4); d10.setAbwicklungskonto(gk4); d11.setAbwicklungskonto(gk4);
            gk4.setDarlehen(listeFuerGirokonto4);
        ArrayList<Darlehen> listeFuerGirokonto5 = new ArrayList<Darlehen>(); // kein darlehen; diese lokale Variable listeFuerGirokonto5 braeuchte man nicht

        // 2 Kundenbetreuer mit jeweils einer Liste von Kontinhabern anlegen
        ArrayList<Kontoinhaber> inhaberliste1 = new ArrayList<Kontoinhaber>();
        ArrayList<Kontoinhaber> inhaberliste2 = new ArrayList<Kontoinhaber>();
        inhaberliste1.add(k1); inhaberliste1.add(k2);
        inhaberliste2.add(k3); inhaberliste2.add(k4); inhaberliste2.add(k5);
        
        Kundenbetreuer kb1 = new Kundenbetreuer(10000, inhaberliste1, 333, 4, "van Helsing", "Dietmar"); Kundenbetreuer kb2 = new Kundenbetreuer(33000, inhaberliste2, 33223, 4, "van Dracula", "Knirschi");

    }
}